package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ProductCollection;
import com.izouma.awesomeadmin.service.ProductCollectionService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/productCollection")
@RequiresAuthentication
public class ProductCollectionController {

    @Autowired
    private ProductCollectionService productCollectionService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ProductCollection record) {
        List<ProductCollection> pp = productCollectionService.getProductCollectionList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getProductCollection", method = RequestMethod.GET)
    @ResponseBody
    public Result getProductCollection(@RequestParam(required = false, value = "id") String id) {
        ProductCollection data = productCollectionService.getProductCollectionById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ProductCollection record) {
        ProductCollection data = productCollectionService.getProductCollection(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ProductCollection record) {
        Map<String, Object> result = new HashMap<>();

        List<ProductCollection> pp =productCollectionService.getProductCollectionByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ProductCollection record) {
        boolean num = productCollectionService.createProductCollection(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateProductCollection(ProductCollection record) {
        boolean num = productCollectionService.updateProductCollection(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteProductCollection(@RequestParam(required = true, value = "id") String id) {

        boolean num = productCollectionService.deleteProductCollection(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ProductCollection record) throws Exception {

    List<ProductCollection> productCollections = productCollectionService.getProductCollectionList(record);


        String sheetName = "product_collection";
        String titleName = "商品收藏数据表";
        String fileName = "商品收藏表";
        int columnNumber = 9;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "类型" ,   "用户" ,   "商品"  };
        String[][] dataList = new String[productCollections.size()][9];

        for (int i = 0; i < productCollections.size(); i++) {

                        dataList[i][0] = String.valueOf(productCollections.get(i).getId());
                        dataList[i][1] = String.valueOf(productCollections.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(productCollections.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(productCollections.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(productCollections.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(productCollections.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(productCollections.get(i).getTypeFlag());
                        dataList[i][7] = String.valueOf(productCollections.get(i).getUserId());
                        dataList[i][8] = String.valueOf(productCollections.get(i).getTargetId());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

